<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [sip.js](./sip.js.md) &gt; [Session](./sip.js.session.md)

## Session class

A session provides real time communication between one or more participants.

<b>Signature:</b>

```typescript
export declare abstract class Session 
```

## Remarks

The transport behaves in a deterministic manner according to the the state defined in [SessionState](./sip.js.sessionstate.md)<!-- -->.

The constructor for this class is marked as internal. Third-party code should not call the constructor directly or create subclasses that extend the `Session` class.

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [assertedIdentity](./sip.js.session.assertedidentity.md) |  | <code>NameAddrHeader &#124; undefined</code> | The asserted identity of the remote user. |
|  [data](./sip.js.session.data.md) |  | <code>unknown</code> | Property reserved for use by instance owner. |
|  [delegate](./sip.js.session.delegate.md) |  | <code>SessionDelegate &#124; undefined</code> | The session delegate. |
|  [dialog](./sip.js.session.dialog.md) |  | <code>SessionDialog &#124; undefined</code> | The confirmed session dialog. |
|  [id](./sip.js.session.id.md) |  | <code>string</code> | A unique identifier for this session. |
|  [localIdentity](./sip.js.session.localidentity.md) |  | <code>NameAddrHeader</code> | The identity of the local user. |
|  [logger](./sip.js.session.logger.md) |  | <code>Logger</code> | Logger. |
|  [remoteIdentity](./sip.js.session.remoteidentity.md) |  | <code>NameAddrHeader</code> | The identity of the remote user. |
|  [replacee](./sip.js.session.replacee.md) |  | <code>Session &#124; undefined</code> | The session being replace by this one. |
|  [sessionDescriptionHandler](./sip.js.session.sessiondescriptionhandler.md) |  | <code>SessionDescriptionHandler &#124; undefined</code> | Session description handler. |
|  [sessionDescriptionHandlerFactory](./sip.js.session.sessiondescriptionhandlerfactory.md) |  | <code>SessionDescriptionHandlerFactory</code> | Session description handler factory. |
|  [sessionDescriptionHandlerModifiers](./sip.js.session.sessiondescriptionhandlermodifiers.md) |  | <code>Array&lt;SessionDescriptionHandlerModifier&gt;</code> | SDH modifiers for the initial INVITE transaction. |
|  [sessionDescriptionHandlerModifiersReInvite](./sip.js.session.sessiondescriptionhandlermodifiersreinvite.md) |  | <code>Array&lt;SessionDescriptionHandlerModifier&gt;</code> | SDH modifiers for re-INVITE transactions. |
|  [sessionDescriptionHandlerOptions](./sip.js.session.sessiondescriptionhandleroptions.md) |  | <code>SessionDescriptionHandlerOptions</code> | SDH options for the initial INVITE transaction. |
|  [sessionDescriptionHandlerOptionsReInvite](./sip.js.session.sessiondescriptionhandleroptionsreinvite.md) |  | <code>SessionDescriptionHandlerOptions</code> | SDH options for re-INVITE transactions. |
|  [state](./sip.js.session.state.md) |  | <code>SessionState</code> | Session state. |
|  [stateChange](./sip.js.session.statechange.md) |  | <code>Emitter&lt;SessionState&gt;</code> | Session state change emitter. |
|  [userAgent](./sip.js.session.useragent.md) |  | <code>UserAgent</code> | The user agent. |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [bye(options)](./sip.js.session.bye.md) |  | End the [Session](./sip.js.session.md)<!-- -->. Sends a BYE. |
|  [dispose()](./sip.js.session.dispose.md) |  | Destructor. |
|  [info(options)](./sip.js.session.info.md) |  | Share [Info](./sip.js.info.md) with peer. Sends an INFO. |
|  [invite(options)](./sip.js.session.invite.md) |  | Renegotiate the session. Sends a re-INVITE. |
|  [message(options)](./sip.js.session.message.md) |  | Deliver a [Message](./sip.js.message.md)<!-- -->. Sends a MESSAGE. |
|  [refer(referTo, options)](./sip.js.session.refer.md) |  | Proffer a [Referral](./sip.js.referral.md)<!-- -->. Send a REFER. |

