<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [sip.js](./sip.js.md) &gt; [UserAgent](./sip.js.useragent.md) &gt; [stop](./sip.js.useragent.stop.md)

## UserAgent.stop() method

Stop the user agent.

<b>Signature:</b>

```typescript
stop(): Promise<void>;
```
<b>Returns:</b>

`Promise<void>`

## Remarks

Resolves when the user agent has completed a graceful shutdown.

```txt
1) Sessions terminate.
2) Registerers unregister.
3) Subscribers unsubscribe.
4) Publishers unpublish.
5) Transport disconnects.
6) User Agent Core resets.

```
NOTE: While this is a "graceful shutdown", it can also be very slow one if you are waiting for the returned Promise to resolve. The disposal of the clients and dialogs is done serially - waiting on one to finish before moving on to the next. This can be slow if there are lot of subscriptions to unsubscribe for example.

THE SLOW PACE IS INTENTIONAL! While one could spin them all down in parallel, this could slam the remote server. It is bad practice to denial of service attack (DoS attack) servers!!! Moreover, production servers will automatically blacklist clients which send too many requests in too short a period of time - dropping any additional requests.

If a different approach to disposing is needed, one can implement whatever is needed and execute that prior to calling `stop()`<!-- -->. Alternatively one may simply not wait for the Promise returned by `stop()` to complete.

