<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [sip.js](./sip.js.md) &gt; [UserAgentOptions](./sip.js.useragentoptions.md)

## UserAgentOptions interface

Options for [UserAgent](./sip.js.useragent.md) constructor.

<b>Signature:</b>

```typescript
export interface UserAgentOptions 
```

## Properties

|  Property | Type | Description |
|  --- | --- | --- |
|  [allowLegacyNotifications](./sip.js.useragentoptions.allowlegacynotifications.md) | <code>boolean</code> | If <code>true</code>, the user agent will accept out of dialog NOTIFY. |
|  [authorizationHa1](./sip.js.useragentoptions.authorizationha1.md) | <code>string</code> | Authorization ha1. |
|  [authorizationPassword](./sip.js.useragentoptions.authorizationpassword.md) | <code>string</code> | Authorization password. |
|  [authorizationUsername](./sip.js.useragentoptions.authorizationusername.md) | <code>string</code> | Authorization username. |
|  [autoStart](./sip.js.useragentoptions.autostart.md) | <code>boolean</code> |  |
|  [autoStop](./sip.js.useragentoptions.autostop.md) | <code>boolean</code> | If <code>true</code>, the user agent calls the <code>stop()</code> method on unload (if running in browser window). |
|  [delegate](./sip.js.useragentoptions.delegate.md) | <code>UserAgentDelegate</code> | Delegate for [UserAgent](./sip.js.useragent.md)<!-- -->. |
|  [displayName](./sip.js.useragentoptions.displayname.md) | <code>string</code> | The display name associated with the user agent. |
|  [forceRport](./sip.js.useragentoptions.forcerport.md) | <code>boolean</code> | Force adding rport to Via header. |
|  [hackAllowUnregisteredOptionTags](./sip.js.useragentoptions.hackallowunregisteredoptiontags.md) | <code>boolean</code> | Hack |
|  [hackIpInContact](./sip.js.useragentoptions.hackipincontact.md) | <code>boolean &#124; string</code> | Hack |
|  [hackViaTcp](./sip.js.useragentoptions.hackviatcp.md) | <code>boolean</code> | Hack |
|  [hackWssInTransport](./sip.js.useragentoptions.hackwssintransport.md) | <code>boolean</code> | Hack |
|  [logBuiltinEnabled](./sip.js.useragentoptions.logbuiltinenabled.md) | <code>boolean</code> | Indicates whether log messages should be written to the browser console. |
|  [logConfiguration](./sip.js.useragentoptions.logconfiguration.md) | <code>boolean</code> | If true, constructor logs the user agent configuration. |
|  [logConnector](./sip.js.useragentoptions.logconnector.md) | <code>LogConnector</code> | A function which will be called every time a log is generated. |
|  [logLevel](./sip.js.useragentoptions.loglevel.md) | <code>LogLevel</code> | Indicates the verbosity level of the log messages. |
|  [noAnswerTimeout](./sip.js.useragentoptions.noanswertimeout.md) | <code>number</code> | Number of seconds after which an incoming call is rejected if not answered. |
|  [preloadedRouteSet](./sip.js.useragentoptions.preloadedrouteset.md) | <code>Array&lt;string&gt;</code> | Adds a Route header(s) to outgoing requests. |
|  [reconnectionAttempts](./sip.js.useragentoptions.reconnectionattempts.md) | <code>number</code> |  |
|  [reconnectionDelay](./sip.js.useragentoptions.reconnectiondelay.md) | <code>number</code> |  |
|  [sessionDescriptionHandlerFactory](./sip.js.useragentoptions.sessiondescriptionhandlerfactory.md) | <code>SessionDescriptionHandlerFactory</code> | A factory for generating <code>SessionDescriptionHandler</code> instances. |
|  [sessionDescriptionHandlerFactoryOptions](./sip.js.useragentoptions.sessiondescriptionhandlerfactoryoptions.md) | <code>object</code> | Options to passed to <code>sessionDescriptionHandlerFactory</code>. |
|  [sipExtension100rel](./sip.js.useragentoptions.sipextension100rel.md) | <code>SIPExtension</code> | Reliable provisional responses. https://tools.ietf.org/html/rfc3262 |
|  [sipExtensionExtraSupported](./sip.js.useragentoptions.sipextensionextrasupported.md) | <code>Array&lt;string&gt;</code> | Extra option tags to claim support for. |
|  [sipExtensionReplaces](./sip.js.useragentoptions.sipextensionreplaces.md) | <code>SIPExtension</code> | Replaces header. https://tools.ietf.org/html/rfc3891 |
|  [sipjsId](./sip.js.useragentoptions.sipjsid.md) | <code>string</code> | An id uniquely identify this user agent instance. |
|  [transportConstructor](./sip.js.useragentoptions.transportconstructor.md) | <code>new (logger: Logger, options: any) =&gt; Transport</code> | A constructor function for the user agent's <code>Transport</code>. |
|  [transportOptions](./sip.js.useragentoptions.transportoptions.md) | <code>unknown</code> | An options bucket object passed to <code>transportConstructor</code> when instantiated. |
|  [uri](./sip.js.useragentoptions.uri.md) | <code>URI</code> | SIP Addresses-of-Record URI associated with the user agent. |
|  [userAgentString](./sip.js.useragentoptions.useragentstring.md) | <code>string</code> | User agent string used in the UserAgent header. |
|  [viaHost](./sip.js.useragentoptions.viahost.md) | <code>string</code> | Hostname to use in Via header. |

