## API Report File for "sip.js"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

// @public
export function defaultMediaStreamFactory(): MediaStreamFactory;

// @public
export function defaultPeerConnectionConfiguration(): RTCConfiguration;

// @public
export function defaultSessionDescriptionHandlerFactory(mediaStreamFactory?: (constraints: MediaStreamConstraints, sessionDescriptionHandler: SessionDescriptionHandler) => Promise<MediaStream>): SessionDescriptionHandlerFactory;

// @public
export type MediaStreamFactory = (constraints: MediaStreamConstraints, sessionDescriptionHandler: SessionDescriptionHandler) => Promise<MediaStream>;

// @public
export interface PeerConnectionDelegate {
    onconnectionstatechange?(event: Event): void;
    ondatachannel?(event: RTCDataChannelEvent): void;
    onicecandidate?(event: RTCPeerConnectionIceEvent): void;
    onicecandidateerror?(event: RTCPeerConnectionIceErrorEvent): void;
    oniceconnectionstatechange?(event: Event): void;
    onicegatheringstatechange?(event: Event): void;
    onnegotiationneeded?(event: Event): void;
    onsignalingstatechange?(event: Event): void;
    onstatsended?(event: Event): void;
    ontrack?(event: Event): void;
}

// Warning: (ae-forgotten-export) The symbol "SessionDescriptionHandler" needs to be exported by the entry point index.d.ts
//
// @public
export class SessionDescriptionHandler implements SessionDescriptionHandler_2 {
    constructor(logger: Logger, mediaStreamFactory: MediaStreamFactory, sessionDescriptionHandlerConfiguration?: SessionDescriptionHandlerConfiguration);
    protected applyModifiers(sdp: RTCSessionDescriptionInit, modifiers?: Array<SessionDescriptionHandlerModifier>): Promise<RTCSessionDescriptionInit>;
    close(): void;
    protected createDataChannel(options?: SessionDescriptionHandlerOptions): Promise<void>;
    protected createLocalOfferOrAnswer(options?: SessionDescriptionHandlerOptions): Promise<RTCSessionDescriptionInit>;
    get dataChannel(): RTCDataChannel | undefined;
    protected _dataChannel: RTCDataChannel | undefined;
    // Warning: (ae-forgotten-export) The symbol "SessionDescriptionHandlerModifier" needs to be exported by the entry point index.d.ts
    // Warning: (ae-forgotten-export) The symbol "BodyAndContentType" needs to be exported by the entry point index.d.ts
    getDescription(options?: SessionDescriptionHandlerOptions, modifiers?: Array<SessionDescriptionHandlerModifier>): Promise<BodyAndContentType>;
    protected getLocalMediaStream(options?: SessionDescriptionHandlerOptions): Promise<void>;
    protected getLocalSessionDescription(): Promise<RTCSessionDescription>;
    hasDescription(contentType: string): boolean;
    holdModifier(sessionDescription: RTCSessionDescriptionInit): Promise<RTCSessionDescriptionInit>;
    protected iceGatheringComplete(): void;
    get localMediaStream(): MediaStream;
    protected _localMediaStream: MediaStream;
    // Warning: (ae-forgotten-export) The symbol "Logger" needs to be exported by the entry point index.d.ts
    protected logger: Logger;
    protected mediaStreamFactory: MediaStreamFactory;
    get peerConnection(): RTCPeerConnection | undefined;
    protected _peerConnection: RTCPeerConnection | undefined;
    get peerConnectionDelegate(): PeerConnectionDelegate | undefined;
    set peerConnectionDelegate(delegate: PeerConnectionDelegate | undefined);
    protected _peerConnectionDelegate: PeerConnectionDelegate | undefined;
    get remoteMediaStream(): MediaStream;
    protected _remoteMediaStream: MediaStream;
    sendDtmf(tones: string, options?: {
        duration: number;
        interToneGap: number;
    }): boolean;
    protected sessionDescriptionHandlerConfiguration?: SessionDescriptionHandlerConfiguration;
    setDescription(sdp: string, options?: SessionDescriptionHandlerOptions, modifiers?: Array<SessionDescriptionHandlerModifier>): Promise<void>;
    protected setLocalMediaStream(stream: MediaStream): Promise<void>;
    protected setLocalSessionDescription(sessionDescription: RTCSessionDescriptionInit): Promise<void>;
    protected setRemoteSessionDescription(sessionDescription: RTCSessionDescriptionInit): Promise<void>;
    protected setRemoteTrack(track: MediaStreamTrack): void;
    protected waitForIceGatheringComplete(restart?: boolean, timeout?: number): Promise<void>;
}

// @public
export interface SessionDescriptionHandlerConfiguration {
    iceGatheringTimeout?: number;
    peerConnectionConfiguration?: RTCConfiguration;
}

// Warning: (ae-forgotten-export) The symbol "SessionDescriptionHandlerFactory" needs to be exported by the entry point index.d.ts
//
// @public
export interface SessionDescriptionHandlerFactory extends SessionDescriptionHandlerFactory_2 {
    // Warning: (ae-forgotten-export) The symbol "Session" needs to be exported by the entry point index.d.ts
    (session: Session, options?: SessionDescriptionHandlerFactoryOptions): SessionDescriptionHandler;
}

// @public
export type SessionDescriptionHandlerFactoryOptions = SessionDescriptionHandlerConfiguration;

// Warning: (ae-forgotten-export) The symbol "SessionDescriptionHandlerOptions" needs to be exported by the entry point index.d.ts
//
// @public
export interface SessionDescriptionHandlerOptions extends SessionDescriptionHandlerOptions_2 {
    answerOptions?: RTCAnswerOptions;
    constraints?: MediaStreamConstraints;
    dataChannel?: boolean;
    dataChannelLabel?: string;
    dataChannelOptions?: RTCDataChannelInit;
    iceGatheringTimeout?: number;
    offerOptions?: RTCOfferOptions;
    onDataChannel?: (dataChannel: RTCDataChannel) => void;
}


```
